# Class MoveAttr`Abstract`

Base class defining all `Move` Attributes

#### Abstract

#### See

`apply`

#### Hierarchy (view full)

- MoveAttr
  - MoveEffectAttr
  - PreMoveMessageAttr
  - StatusMoveTypeImmunityAttr
  - IgnoreOpponentStatChangesAttr
  - HighCritAttr
  - CritOnlyAttr
  - FixedDamageAttr
  - ModifiedDamageAttr
  - IgnoreWeatherTypeDebuffAttr
  - IncrementMovePriorityAttr
  - MultiHitAttr
  - ChangeMultiHitTypeAttr
  - BypassSleepAttr
  - BypassBurnDamageReductionAttr
  - OneHitKOAttr
  - OverrideMoveEffectAttr
  - PostVictoryStatChangeAttr
  - VariablePowerAttr
  - VariableAtkAttr
  - VariableDefAttr
  - VariableAccuracyAttr
  - VariableMoveCategoryAttr
  - VariableMoveTypeAttr
  - VariableMoveTypeMultiplierAttr
  - MissEffectAttr
  - NoEffectAttr
  - TypelessAttr
  - BypassRedirectAttr
  - HitsTagAttr
  - DiscourageFrequentUseAttr
  - LastResortAttr
  - VariableTargetAttr

- Defined in src/data/move.ts:716

#####
Index

### Constructors

constructor

### Properties

selfTarget

### Methods

apply
getCondition
getFailedText
getTargetBenefitScore
getUserBenefitScore

## Constructors

### constructor

- new MoveAttr(selfTarget?): MoveAttr

- #### Parameters

  - selfTarget: boolean = false

  #### Returns MoveAttr

  - Defined in src/data/move.ts:720

## Properties

### selfTarget

selfTarget: boolean

Should this `Move` target the user?

- Defined in src/data/move.ts:718

## Methods

### apply

- apply(user, target, move, args): boolean | Promise<boolean>

- Applies move attributes

  #### Parameters

  - user: default

    `Pokemon` using the move

  - target: default

    `Pokemon` target of the move

  - move: default

    `Move` with this attribute

  - args: any[]

    Set of unique arguments needed by this attribute

  #### Returns boolean | Promise<boolean>

  true if application of the ability succeeds

  #### See

  applyMoveAttrsInternal

  - Defined in src/data/move.ts:734

### getCondition

- getCondition(): MoveCondition | MoveConditionFunc

- #### Returns MoveCondition | MoveConditionFunc

  the `MoveCondition` or MoveConditionFunc for this `Move`

  - Defined in src/data/move.ts:742

### getFailedText

- getFailedText(user, target, move, cancelled): string

- #### Parameters

  - user: default

    `Pokemon` using the move

  - target: default

    `Pokemon` target of the move

  - move: default

    `Move` with this attribute

  - cancelled: BooleanHolder

    `Utils.BooleanHolder` which stores if the move should fail

  #### Returns string

  the string representing failure of this `Move`

  - Defined in src/data/move.ts:754

### getTargetBenefitScore

- getTargetBenefitScore(user, target, move): number

- Used by the Enemy AI to rank an attack based on a given target

  #### Parameters

  - user: default
  - target: default
  - move: default

  #### Returns number

  #### See

  `EnemyPokemon.getNextMove`

  - Defined in src/data/move.ts:772

### getUserBenefitScore

- getUserBenefitScore(user, target, move): number

- Used by the Enemy AI to rank an attack based on a given user

  #### Parameters

  - user: default
  - target: default
  - move: default

  #### Returns number

  #### See

  `EnemyPokemon.getNextMove`

  - Defined in src/data/move.ts:763